/***********************************************************
 *   Bpm Live - Live BPM counting
 *-----------------------------------------------------------
 *  Copyright (c) 2004 Werner Van Belle, see copyright.txt
 *  http://werner.onlinux.be/bpmlive/
 *  e-mail: werner.van.belle@itek.norut.no
 ***********************************************************/

/**-------------------------------------------
 * 		Imports
 **-------------------------------------------*/
#include <fftw3.h>
#include "bpmlive-signal.h"
#include "bpmlive.h"
class dsp_alsa;

/**-------------------------------------------
 * 		Imports
 **-------------------------------------------*/
class BpmCounter
{
private:
	dsp_alsa * dsp;
	int measured;
	sample_type *block;
	Signal audio;
	int b1, b2;
	double * mask;
	double * en;
	double * ts;
	double * co;
	fftw_plan forward;
	fftw_plan backward;
	double sample_rate;
public:
	BpmCounter(dsp_alsa * dsp) { init(dsp); };
	void init(dsp_alsa * dsp);
	double measure();
};

