/***************************************************************************
 *  BpmDj: Free Dj Tools
 * -------------------------------------------------------------------------
 *  Copyright (C) 2004 by Werner Van Belle, see copyright.txt
 *  http://bpmdj.sourceforge.net/
 *  e-mail: werner.van.belle@itek.norut.no                                
 ***************************************************************************/

#ifndef DSP_ALSA_H
#define DSP_ALSA_H

/**-------------------------------------------
 * 		Imports
 **-------------------------------------------*/
#include "version.h"

#define ALSA_OPTION_HELP ""

#ifdef COMPILE_ALSA
#include <alsa/asoundlib.h>
#include "dsp-drivers.h"
#include "inout.h"
#include "bpmlive.h"

/**-------------------------------------------
 * 		DSP Read class
 **-------------------------------------------*
 * Based upon code from BpmDj
 */
class dsp_alsa: public dsp_driver
{
 private:
  snd_pcm_t *dsp;
  snd_pcm_uframes_t buffer_size;
  snd_pcm_uframes_t period_size;
  Buffer<sample_type> * buffer;
  int wavrate;
 public:
  char *     arg_latency;
  dsp_alsa();
  void    start();
  void    run();
  virtual void read(sample_type *target, int length) ;
  signed8 latency();
  int     get_max_read();
  int     get_wavrate() {return wavrate;};
  int     open(char * arg_dev, int read_time, int wavrate);
  void    close();
};

#endif

#endif
