/***************************************************************************
 *  BpmDj: Free Dj Tools
 * -------------------------------------------------------------------------
 *  Copyright (C) 2004 by Werner Van Belle, see copyright.txt
 *  http://bpmdj.sourceforge.net/
 *  e-mail: werner.van.belle@itek.norut.no                                
 ***************************************************************************/

#ifndef DSP_DRIVERS
#define DSP_DRIVERS

/**-------------------------------------------
 * 		Imports
 **-------------------------------------------*/
#include "version.h"
#include "common.h"
#include "stereo-sample2.h"
#include "bpmlive.h"

#ifndef COMPILE_OSS
#ifndef COMPILE_ALSA
#error -------------------------------------------
#error Should at least compile one dsp driver !!! 
#error Try using -D COMPILE_OSS, -D COMPILE_ALSA 
#error -------------------------------------------
#endif
#endif

/**-------------------------------------------
 * 		DSP Operations
 **-------------------------------------------*/
#define err_dsp (-1)
#define err_none (0)

class dsp_driver
{
 public:
  bool verbose;
  dsp_driver() { verbose = true; };
  virtual ~dsp_driver() {};
  virtual void start() = 0;
  virtual void read(sample_type *, int length) = 0;
  virtual signed8 latency() = 0;
  virtual int  open(char* arg_dev, int read_time, int wavrate) = 0;
  virtual void close() = 0;
};

#endif
