/***********************************************************
 *   Bpm Live - Live BPM counting
 *-----------------------------------------------------------
 *  Copyright (c) 2004 Werner Van Belle, see copyright.txt
 *  http://werner.onlinux.be/bpmlive/
 *  e-mail: werner.van.belle@itek.norut.no
 ***********************************************************/

#ifndef BUFFER_H
#define BUFFER_H
 
 /**
  * The in-out buffer is a typical producer consumer buffer.
  * One thread can pull data out of the buffer, while another one can put data 
  * into it. The buffer is non-continue in the sense that the one pulling
  * might be missing data or might be seeing the same data over and over.
  */
  
template <class T> class Buffer
{
	T * content;
	int most_recent_pos;
	int max_read;
	int max_write;
	int total_size;
public:
	Buffer(int mr, int mw);
	void push(T * source, int length);
	void pull(T * target, int length);
	int get_max_read() { return max_read; };
};

#endif
