/***********************************************************
 *   Bpm Live - Live BPM counting
 *-----------------------------------------------------------
 *  Copyright (c) 2004 Werner Van Belle, see copyright.txt
 *  http://werner.onlinux.be/bpmlive/
 *  e-mail: werner.van.belle@itek.norut.no
 ***********************************************************/
#ifndef BPMLIFELOGIC_H
#define BPMLIFELOGIC_H

/**-------------------------------------------
 * 		Imports
 **-------------------------------------------*/
#include "dialog.h"
class dsp_alsa;
class BpmCounter;
class Meter;
class Metronome;

/**-------------------------------------------
 * 	BpmLifeLogic: Main window
 **-------------------------------------------*/
class Logic: public BpmLive
{
private:
	int history_length;
	double *history1;
	int history_next;
	void instant_tempo(double bpm1);
	
	/**
	 * The DSP devices in use and the functions to aopen/close them
	 */
	int wavrate;
	dsp_alsa *dsp1_in;
	void open_dsp(int time);
	
	/** 
	 * The bpm analysis functions
	 */
	 BpmCounter * bpmcounter1;
	 void init_bpmcounter();
	 
	 /**
	  * The meter display
	  */
	  Meter * meter1;
	  void init_meter();

  	 /**
	  * The metronome and global tempo
	  */
	  Metronome * metronome;
	  void init_metronome();

 public slots:
 
	Logic( QWidget* parent = NULL, const char* name = "BpmDj Life Counter", bool modal = false, WFlags fl = 0);
	virtual void start_tracing();
	virtual void done(int result);
 };

#endif
