/***************************************************************************
 *  BpmDj: Free Dj Tools
 * -------------------------------------------------------------------------
 *  Copyright (C) 2004 by Werner Van Belle, see copyright.txt
 *  e-mail: werner.van.belle@itek.norut.no                                
 ***************************************************************************/

#include <stdio.h>
#include <assert.h>
#include "memory.h"
#include "malloc.h"

void myfree(void* a)
{
    free(a);
}

void* myalloc(int length, const char* file, int line)
{
  void * result;
  assert(length>=0);
  result = malloc(length);
#ifdef COUNT_ALLOCATIONS
  static int nrallocs = 0;
  nrallocs++;
  if (nrallocs%100==0)
    printf("%d allocs ",nrallocs);
#endif
  if (!result)
    printf("Error: %s(%d): unable to allocate %d bytes \n",file,line,length);
  assert(result);
  return result;
}

void* myrealloc(void* thing, int size)
{
  void * result;
  assert(size);
  result = realloc(thing,size);
  assert(result);
  return result;
}

