/***********************************************************
 *   Bpm Live - Live BPM counting
 *-----------------------------------------------------------
 *  Copyright (c) 2004 Werner Van Belle, see copyright.txt
 *  http://werner.onlinux.be/bpmlive/
 *  e-mail: werner.van.belle@itek.norut.no
 ***********************************************************/

#include "meter.h"
#include "dsp-alsa.h"
#include "bpmlive.h"

int Meter::measure()
{
   sample_type block[bs];
   dsp->read(block,bs);
   int max = 0;
   for(int i = 0 ; i < bs ; i ++)
	 {
	 #ifdef MONO8BIT
	 if (abs(block[i]) > max)
	 	max = abs(block[i]);
	 #endif
	 
	 #ifdef STEREO16BIT
	 if (abs(block[i].left) > max)
	 	max = abs(block[i].left);
	 if (abs(block[i].right) > max)
	 	max = abs(block[i].right);
	 #endif
	 }
#ifdef SHOW_METERS
static int last_printed = 0;
   if (last_printed!=max) 
     printf("%d\n",last_printed=max);
#endif
   return max;
}
