/***********************************************************
 *   Bpm Live - Live BPM counting
 *-----------------------------------------------------------
 *  Copyright (c) 2004 Werner Van Belle, see copyright.txt
 *  http://werner.onlinux.be/bpmlive/
 *  e-mail: werner.van.belle@itek.norut.no
 ***********************************************************/

#include <pthread.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <sys/time.h>
#include <math.h>
#include "metronome.h"
#include "unistd.h"
#include "memory.h"
#include "bpmlive.h"
#include <qlcdnumber.h>

static Metronome * tostart;

static void * go(void* neglect)
{
	tostart -> run();
	return neglect;
}

void Metronome::start()
{
	pthread_t *y = Allocate(1,pthread_t);
	tostart = this;
	pthread_create(y,NULL,go,NULL);	
}

void Metronome::run()
{
	timeval started;
	timeval current;
	int overdue = 0;
	while(!final_stop)
		{
		double B = beat();
		if (B<80) B = 80;
		if (B>180) B = 180;
		gettimeofday(&started,NULL);
		int towait = (int)(1000000.0 * 60.0/B);
		towait -= overdue;
		usleep(towait);
		gettimeofday(&current,NULL);
		int s = (current.tv_sec-started.tv_sec);
		int ms = (current.tv_usec-started.tv_usec);
		overdue = s * 1000000 + ms;
		overdue -= towait;
		}
}

double Metronome::beat()
{
	static int beatnr = 0 ;
	printf("           ***\n");
	beatnr++;
	return bpm1;
}
